package myPlayStationFriends;

import myPlayStationFriends.Trophy.Rank;
import myPlayStationFriends.Trophy.Rarity;

public class AVLTree {

	public user root;
	public AVLTree() {
		root=null;
	}
	int height(user N) {
		if(N==null) {
			return 0;
		}
		return N.getLevel();
	}
	int max(int a ,int b) {
		return (a>b)?a:b;
	}
	public user rightRotate(user y) {
		user x=y.getLeft();
		user T2=x.getRight();
		
		// Perform rotation 
        x.setRight(y); 
        y.setLeft(T2); 
  
        // Update heights 
        y.setLevel(max(height(y.getLeft()), height(y.getRight())) + 1); 
        x.setLevel(max(height(y.getLeft()), height(x.getRight())) + 1); 
  
        // Return new root 
        return x; 
	}
	public user leftRotate(user x) {
		user y = x.getRight(); 
        user T2 = y.getLeft(); 
  
        // Perform rotation 
        y.setLeft( x); 
        x.setRight(T2); 
  
        //  Update heights 
        x.setLevel(max(height(x.getLeft()), height(x.getRight())) + 1); 
        y.setLevel(max(height(y.getLeft()), height(y.getRight())) + 1); 
  
        // Return new root 
        return y; 
	}
	int getBalance(user n) {
		if(n==null) {
			return 0;
		}
		else
		{
			return height(n.getLeft())-height(n.getRight());
		}
	}
	public user insert(user node, user friend) { 
		  
	        /* 1.  Perform the normal BST insertion */
	        if (node == null) {
	           root=friend;
	           return root;
	        }
	        if (friend.getKey() < node.getKey()) 
	            node.setLeft(insert(node.getLeft(), friend)); 
	        else if (friend.getKey() > node.getKey()) 
	            node.setRight(insert(node.getRight(), friend)); 
	        else // Duplicate keys not allowed 
	            return node; 
	  
	        /* 2. Update height of this ancestor node */
	        node.setLevel( 1 + max(height(node.getLeft()), 
	                              height(node.getRight()))); 
	  
	        /* 3. Get the balance factor of this ancestor 
	              node to check whether this node became 
	              unbalanced */
	        int balance = getBalance(node); 
	  
	        // If this node becomes unbalanced, then there 
	        // are 4 cases Left Left Case 
	        if (balance > 1 && friend.getKey() < node.getLeft().getKey()) 
	            return rightRotate(node); 
	  
	        // Right Right Case 
	        if (balance < -1 && friend.getKey() > node.getRight().getKey()) 
	            return leftRotate(node); 
	  
	        // Left Right Case 
	        if (balance > 1 && friend.getKey() > node.getLeft().getKey()) { 
	            node.setLeft(leftRotate(node.getLeft())); 
	            return rightRotate(node); 
	        } 
	  
	        // Right Left Case 
	        if (balance < -1 && friend.getKey() < node.getRight().getKey()){ 
	            node.setRight(rightRotate(node.getRight())); 
	            return leftRotate(node); 
	        } 
	  
	        /* return the (unchanged) node pointer */
	        return node; 
	    } 
	public boolean AddAVL(user friend) {
		root=insert(root,friend);
		if(root!=null) {
			return true;
		}
		else {
			return false;
		}
	}
	public void  preorder(user node) { 
	        if (node != null) { 
	        	
	            System.out.print(node.getUsername() + " "); 
	            preorder(node.getLeft()); 
	            preorder(node.getRight()); 
	        } 
	    } 
	void preorder() {
		preorder(root);
	}
	public int countNodes()
    {
        return countNodes(root);
    }
    private int countNodes(user r)
    {
        if (r == null)
            return 0;
        else
        {
            int l = 1;
            l += countNodes(r.getLeft());
            l += countNodes(r.getRight());
            return l;
        }
    }
}
