package myPlayStationFriends;

import myPlayStationFriends.Trophy.Rank;
import myPlayStationFriends.Trophy.Rarity;

public class BinarySearchTree {
	public user root;
	
	public BinarySearchTree() {
		
		root=null;
		
	}
	public void beFriend(user friend) {
		if(friend==null) {
			throw new IllegalArgumentException("Null Argument");
		}
		root=insert(root,friend);
	}
	public user insert(user node,user friend)
	{
		if(node==null) {
			node=friend;
		}
		else if(!node.getUsername().equals(friend.getUsername())) {
			
			if(friend.getKey()<=node.getKey()) {
				
				node.setLeft(insert(node.getLeft(),friend));
			}
			else {
				node.setRight(insert(node.getRight(),friend));
			}
		}
		return node;
	}
	public void preorder(user u) {
		
		if (u != null)
        {
            System.out.println(u.ToString());
            preorder(u.getLeft());             
            preorder(u.getRight());
        }
	}
	public void preorder()
	{
		preorder(root);
	}
	public void addGame(user u,String name,Game game) {
		
		if (u != null)
        {
            if(u.getUsername().equals(name)) 
            {
            	u.getGames().addGame(game);
            }
            addGame(u.getLeft(),name,game);             
            addGame(u.getRight(),name,game);
        }
		
		
	}
	public void addGame(String name,Game game)
	{
		if(game==null) {
			throw new IllegalArgumentException("Null argument");
		}
		addGame(root,name,game);
	}

public void addTrophy(user u,String name,Trophy e) {
		
		if (u != null)
        {
            if(u.getUsername().equals(name)) 
            {
            	u.getTrophies().add(e);
            }
            addTrophy(u.getLeft(),name,e);             
            addTrophy(u.getRight(),name,e);
        }
		
		
	}
	public void addTrophy(String name,Trophy t)
	{
		if(t==null) {
			throw new IllegalArgumentException("Null argument");
		}
		addTrophy(root,name,t);
	}
	public user delete(user node,user friend) {
		user p,p2,n;
		if (node.getKey() == friend.getKey())
        {
            user lt, rt;
            lt = node.getLeft();
            rt = node.getRight();
            if (lt == null && rt == null)
                return null;
            else if (lt == null)
            {
                p = rt;
                return p;
            }
            else if (rt == null)
            {
                p = lt;
                return p;
            }
            else
            {
                p2 = rt;
                p = rt;
                while (p.getLeft() != null)
                    p = p.getLeft();
                p.setLeft(lt);
                return p2;
            }
        }
        if (friend.getKey() < node.getKey())
        {
            n = delete(node.getLeft(), friend);
            node.setLeft(n);
        }
        else
        {
            n = delete(root.getRight(), friend);
            node.setRight(n);             
        }
        return node;
    }
	public boolean deFriend(user friend)
	{
		if(friend==null) {
			throw new IllegalArgumentException("Null argument");
		}
		if (root==null)
            return false;
        else if (search(friend) == false)
            return false;
        else
        {
            root = delete(root, friend);
            return true;
        }
		
	}
	public user levelUpSearch(String name,user u) {
		
		if (u != null)
        {
            if(u.getUsername().equals(name)) 
            {
            	return u;
            }
            levelUpSearch(name,u.getLeft());             
            levelUpSearch(name,u.getRight());
        }
		return null;
		
	}
	public void levelUp(String username) {
		if(username==null) {
			throw new IllegalArgumentException("Not null");
		}
		user c=new user();
		c=levelUpSearch(username,root);
		user newUser=new user(c);
		
		
		if(c!=null) {
			int level=c.getLevel()+1;
			if(deFriend(c)) {
				beFriend(newUser);
			}
			
			
		}
	}
	 public boolean search(user friend)
     {
         return search(root, friend);
     }
     /* Function to search for an element recursively */
     private boolean search(user r, user friend)
     {
         boolean found = false;
         while ((r != null) && !found)
         {
             double rval = r.getKey();
             if (friend.getKey() < rval)
                 r = r.getLeft();
             else if (friend.getKey() > rval)
                 r = r.getRight();
             else
             {
                 found = true;
                 break;
             }
             found = search(r, friend);
         }
         return found;
     }
     public int countBetterPlayers(user reference) {
    	 if(reference==null) {
    		 throw new IllegalArgumentException("Null Argument");
    	 }
    	 int better=0;
    	 user current,pre;
    	 user r=reference;
    	
    	 
    		 if (reference == null) 
    		        return 0; 
    		  
    		    current = root; 
    		    while (current != null) { 
    		  
    		        if (current.getLeft() == null) { 
    		            if(r.getTrophyRankSum()<current.getTrophyRankSum()) {
    		            	better=better+1;
    		            }
    		            current = current.getRight(); 
    		        } 
    		        else { 
    		  
    		            /* Find the inorder predecessor of current */
    		            pre = current.getLeft() ;
    		            while (pre.getRight() != null && pre.getRight() != current) 
    		                pre = pre.getRight(); 
    		  
    		            /* Make current as the right child of its inorder  
    		               predecessor */
    		            if (pre.getRight()==null) { 
    		                pre.setRight(current); 
    		                current = current.getLeft(); 
    		            } 
    		  
    		            /* Revert the changes made in the 'if' part to restore  
    		               the original tree i.e., fix the right child 
    		               of predecessor */
    		            else { 
    		                pre.setRight(null); 
    		                System.out.println(r.getTrophyRankSum());
    		                if(r.getTrophyRankSum()<current.getTrophyRankSum())
    		                {
    		                	
    		                	better=better+1;
    		                }
    		                current = current.getRight(); 
    		            } /* End of if condition pre->right == NULL */
    		        } /* End of if condition current->left == NULL*/
    		    }
				return better;
             
             
             
         }
     public int countWorsePlayers(user reference) {
    	 if(reference==null) {
    		 throw new IllegalArgumentException("Null Argument");
    	 }
    	 int better=0;
    	 user current,pre;
    	 user r=reference;
    	
    	 
    		 if (reference == null) 
    		        return 0; 
    		  
    		    current = root; 
    		    while (current != null) { 
    		  
    		        if (current.getLeft() == null) { 
    		            if(r.getTrophyRankSum()>current.getTrophyRankSum()) {
    		            	better=better+1;
    		            }
    		            current = current.getRight(); 
    		        } 
    		        else { 
    		  
    		            /* Find the inorder predecessor of current */
    		            pre = current.getLeft() ;
    		            while (pre.getRight() != null && pre.getRight() != current) 
    		                pre = pre.getRight(); 
    		  
    		            /* Make current as the right child of its inorder  
    		               predecessor */
    		            if (pre.getRight()==null) { 
    		                pre.setRight(current); 
    		                current = current.getLeft(); 
    		            } 
    		  
    		            /* Revert the changes made in the 'if' part to restore  
    		               the original tree i.e., fix the right child 
    		               of predecessor */
    		            else { 
    		                pre.setRight(null); 
    		                if(r.getTrophyRankSum()>current.getTrophyRankSum()) {
    		                	better=better+1;
    		                }
    		                current = current.getRight(); 
    		            } /* End of if condition pre->right == NULL */
    		        } /* End of if condition current->left == NULL*/
    		    }
				return better;
             
             
             
         }
     public user mostPlatinums(user reference) {
    	 if(reference==null) {
    		 throw new IllegalArgumentException("Null Argument");
    	 }
    	 int better=0;
    	 user current,pre;
    	 int max=0;
    	 user r=reference;
    	 user most=null;
    	
    	 
    		
    		  
    		    current = root; 
    		    while (current != null) { 
    		  
    		        if (current.getLeft() == null) { 
    		        	for(int i=0;i<r.getTrophies().size();i++) {
    		            if(r.getTrophies().get(i).equals(Rank.PLATINUM)) {
    		            	better=better+1;
    		            }}
    		        	if(max<better) {
    		        		
    		        		max=better;
    		        		most=current;
    		        	}
    		            current = current.getRight(); 
    		        } 
    		        else { 
    		  
    		            /* Find the inorder predecessor of current */
    		            pre = current.getLeft() ;
    		            while (pre.getRight() != null && pre.getRight() != current) 
    		                pre = pre.getRight(); 
    		  
    		            /* Make current as the right child of its inorder  
    		               predecessor */
    		            if (pre.getRight()==null) { 
    		                pre.setRight(current); 
    		                current = current.getLeft(); 
    		            } 
    		  
    		            /* Revert the changes made in the 'if' part to restore  
    		               the original tree i.e., fix the right child 
    		               of predecessor */
    		            else { 
    		                pre.setRight(null); 
    		                for(int i=0;i<r.getTrophies().size();i++) {
    	    		            if(r.getTrophies().get(i).equals(Rank.PLATINUM)) {
    	    		            	better=better+1;
    	    		            }}
    		                if(max<better) {
        		        		max=better;
        		        		most=current;
        		        	}
    		                current = current.getRight(); 
    		            } /* End of if condition pre->right == NULL */
    		        } /* End of if condition current->left == NULL*/
    		    }
				return most;
             
             
             
         }
     public user mostPlatinums() {
    	 
    	 return mostPlatinums(root);
     }
   
     public int countNodes()
     {
         return countNodes(root);
     }
     /* Function to count number of nodes recursively */
     private int countNodes(user r)
     {
         if (r == null)
             return 0;
         else
         {
             int l = 1;
             l += countNodes(r.getLeft());
             l += countNodes(r.getRight());
             return l;
         }
     } 
     
	
}
