package myPlayStationFriends;

public class GameList {
	Game head;
	public GameList() {
		head=null;
	}
	public void addGame(Game game)
	{   //throw null argument
		if(game==null) {
			throw new IllegalArgumentException("Null Argument");
		}
		
		game.setNext(null);
		
		if(head==null) {
			System.out.println();
			head=game;
		}
		else
		{
			Game last=head;
			while(last.getNext()!=null) {
				if(getGame(game.getName())!=null) {
					return;
				}
				last=last.getNext();
			}
			last.setNext(game);
		}
	}
	public Game getGame(String name) {
		if(name==null)
		{
			throw new IllegalArgumentException("Null argument");
		}
		else {
			Game currNode=this.head;
			 while (currNode != null) { 
		            // if currNode name is equal to the name 
				 	if(currNode.getName().equals(name)) {
				 		return currNode;
				 	}
		    
		            // Go to next node 
		            currNode = currNode.getNext(); 
		        } 
			
		}
		return null;
	}
	public void printList() {
		Game currNode=this.head;
		 while (currNode != null) { 
	            // Print the data at current node 
	            System.out.print(currNode.getName() + " "); 
	   
	            // Go to next node 
	            currNode = currNode.getNext(); 
	        } 
	}
	public void removeGame(String name) {
		if(name==null)
		{
			throw new IllegalArgumentException("null argument");
		}
		Game currNode = this.head;
		Game prev=null;
		// CASE 1: 
        // If head node itself holds the key to be deleted 
		 if (currNode != null && currNode.getName().equals(name)) { 
	            this.head = currNode.getNext(); // Changed head 
	  
	            // Display the message 
	            System.out.println(name + " found and deleted"); 
	            return;
	        } 
		 	// CASE 2: 
	        // If the key is somewhere other than at head 
	        // 
	  
	        // Search for the key to be deleted, 
	        // keep track of the previous node 
	        // as it is needed to change currNode.next 
	        while (currNode != null && !currNode.getName().equals(name)) { 
	            // If currNode does not hold key 
	            // continue to next node 
	            prev = currNode; 
	            currNode = currNode.getNext(); 
	        } 
	     // If the key was present, it should be at currNode 
	        // Therefore the currNode shall not be null 
	        if (currNode != null) { 
	            // Since the key is at currNode 
	            // Unlink currNode from linked list 
	            prev.setNext(currNode.getNext()); 
	  
	            // Display the message 
	            System.out.println(name + " found and deleted"); 
	        } 
	  
	        // 
	        // CASE 3: The key is not present 
	        // 
	  
	        // If key was not present in linked list 
	        // currNode should be null 
	        if (currNode == null) { 
	            // Display the message 
	            System.out.println(name + " not found"); 
	        } 
	}
	public void removeGame(Game game) {
		if(game==null)
		{
			throw new IllegalArgumentException("null argument");
		}
		Game currNode = this.head;
		Game prev=null;
		// CASE 1: 
        // If head node itself holds the key to be deleted 
		 if (currNode != null && currNode==game) { 
	            this.head = currNode.getNext(); // Changed head 
	  
	          
	            return;
	        } 
		 	// CASE 2: 
	        // If the key is somewhere other than at head 
	        // 
	  
	        // Search for the key to be deleted, 
	        // keep track of the previous node 
	        // as it is needed to change currNode.next 
	        while (currNode != null && currNode!=game) { 
	            // If currNode does not hold key 
	            // continue to next node 
	            prev = currNode; 
	            currNode = currNode.getNext(); 
	        } 
	     // If the key was present, it should be at currNode 
	        // Therefore the currNode shall not be null 
	        if (currNode != null) { 
	            // Since the key is at currNode 
	            // Unlink currNode from linked list 
	            prev.setNext(currNode.getNext()); 
	  
	            
	        } 
	  
	        // 
	        // CASE 3: The key is not present 
	        // 
	  
	        // If key was not present in linked list 
	        // currNode should be null 
	        if (currNode == null) { 
	            // Display the message 
	            System.out.println(game.getName() + " not found"); 
	        } 
	}
	public String ToString() {
		Game currNode=this.head;
		String str="";
		 while (currNode != null) { 
	            // Print the data at current node 
	            str=str+(currNode.ToString()+"\n"); 
	   
	            // Go to next node 
	            currNode = currNode.getNext(); 
	        } 
		 return str;
	}
	
}
