package myPlayStationFriends;

import java.util.Calendar;
import java.util.Formatter;

public class Trophy {
	public enum Rank {
		BRONZE, SILVER, GOLD, PLATINUM
		} public enum Rarity {
		COMMON, UNCOMMON, RARE, VERY_RARE, ULTRA_RARE
		}
		private String name; 
		private Rank rank; 
		private Rarity rarity; 
		private Calendar obtained; 
		private Game game;
		public Trophy() {
			name=null;
			rank=null;
			rarity=null;
			obtained=Calendar.getInstance();
			game=null;
		}
		public String getName() {
			return name;
		}
		public void setName(String name) {
			this.name = name;
		}
		public Rank getRank() {
			return rank;
		}
		public void setRank(Rank rank) {
			this.rank = rank;
		}
		public Rarity getRarity() {
			return rarity;
		}
		public void setRarity(Rarity rarity) {
			this.rarity = rarity;
		}
		public Calendar getObtained() {
			return obtained;
		}
		public void setObtained(Calendar obtained) {
			this.obtained = obtained;
		}
		public Game getGame() {
			return game;
		}
		public void setGame(Game game) {
			this.game = game;
		}
		public int getRankInt() {
			if(getRank().equals(Rank.GOLD))
			{
				return 3;
			}
			else if(getRank().equals(Rank.BRONZE))
			{
				return 1;
			}
			else if(getRank().equals(Rank.SILVER))
			{
				return 2;
			}
			else if(getRank().equals(Rank.PLATINUM))
			{
				return 4;
			}
			return 0;
			
		}
		public String ToString() {
			Formatter fmt=new Formatter();
			return '"'+getName()+"\""+", rank: "+getRank()+", rarity: "+getRarity()+", obtained on: "+fmt.format("%tb",getObtained())+" "+getObtained().get(Calendar.DATE)+","+getObtained().get(Calendar.YEAR);
		}

}
