package myPlayStationFriends;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Formatter;

public class user {
	
	private String username; 
	private int level; 
	private double key; 
	private ArrayList<Trophy> trophies; 
	private GameList games; 
	private Calendar dob; 
	private user left;
	private user right;
	int year,month,day;
	
	public user() {
		games=new GameList();
		left=null;
		right=null;
		trophies=new ArrayList<Trophy>();
		key=0.00;
		level=0;
		username=null;
		dob=Calendar.getInstance();
	}
	private double calculateKey()
	{ 
		int hash = Math.abs(username.hashCode()); 
	// Calculate number of zeros we need 
	int length = (int)(Math.log10(hash) + 1);
	// Make a divisor 10^length
	double divisor = Math.pow(10, length);
	// Return level.hash 
	return level + hash / divisor;
	}
	public void setKey()
	{
		this.key=calculateKey();
	}
	public double getKey() {
		return this.key;
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public int getLevel() {
		return level;
	}

	public void setLevel(int level) {
		this.level = level;
	}

	public ArrayList<Trophy> getTrophies() {
		return trophies;
	}

	public void setTrophies(ArrayList<Trophy> trophies) {
		this.trophies = trophies;
	}

	public Calendar getDob() {
		return dob;
	}

	public void setDob() {
		this.dob = Calendar.getInstance();
	}

	public user getLeft() {
		return left;
	}

	public void setLeft(user left) {
		this.left = left;
	}
	

	public int getYear() {
		return year;
	}
	public void setYear(int year) {
		this.year = year;
	}
	public int getMonth() {
		return month;
	}
	public void setMonth(int month) {
		this.month = month;
	}
	public int getDay() {
		return day;
	}
	public void setDay(int day) {
		this.day = day;
	}
	public user getRight() {
		return right;
	}

	public void setRight(user right) {
		this.right = right;
	}
	
	public GameList getGames()
	{
		return games;
	}
	public void setGame(GameList g)
	{
		this.games=g;
	}
	public int getTrophyRankSum() {
		int sum=0;
		for(int i=0;i<trophies.size();i++) {
			sum=sum+trophies.get(i).getRankInt();
		}
		
		return sum;
	}
	public String getFormattedDob() {
		Formatter fm=new Formatter();
		getDob().set(year,month,day);
		return fm.format("%tb",getDob())+" "+getDob().get(Calendar.DATE)+","+getDob().get(Calendar.YEAR);
	}
	public user(user c) {
		this.username=c.username;
		this.day=c.day;
		this.dob=c.dob;
		this.games=c.games;
		this.trophies=c.trophies;
		this.month=c.month;
		this.year=c.year;
		this.right=null;
		this.left=null;
		this.key=c.key;
		this.level=c.level;
	}
	public String ToString() {
		
		String str="";
		String trophies="";
		for(int i=0;i<getTrophies().size();i++) {
			trophies=trophies+getTrophies().get(i).ToString()+"\n";
		}
		
		str=str+"User: "+getUsername()+"\n"+"Trophies: \n"+trophies+"\n"+"Games: \n"+getGames().ToString()+"\n\n Date Of Birth: "+getFormattedDob();
		return str;
	}
	}


