package myPlayStationFriends_testing;

import static org.junit.Assert.*;

import java.util.Calendar;

import org.junit.Assert;
import org.junit.Test;

import myPlayStationFriends.Game;
import myPlayStationFriends.GameList;

public class GameListTester {

	@Test(expected=IllegalArgumentException.class)
	public void getGameNullArg() {
		Game game=null;
		GameList games=new GameList();
		games.getGame(null);
		
		
	}
	
	
	@Test
	public void testAddGame() {
		GameList games=new GameList();
		Game game=new Game();
		game.setName("The two thrones");
		game.getReleased().set(1999,9,29);
		game.setTotalTrophies(2);
		games.addGame(game);
		
		Assert.assertEquals("\""+game.getName()+"\""+", released on: "+game.getFmt().format("%tb",game.getReleased())+" "+game.getReleased().get(Calendar.DATE)+","+game.getReleased().get(Calendar.YEAR),games.getGame("The two thrones").ToString());	}

	@Test
	public void testGetGame() {
		GameList games=new GameList();
		Game game=new Game();
		game.setName("The two thrones");
		game.getReleased().set(1999,9,29);
		game.setTotalTrophies(2);
		games.addGame(game);
		
		Assert.assertEquals("\""+game.getName()+"\""+", released on: "+game.getFmt().format("%tb",game.getReleased())+" "+game.getReleased().get(Calendar.DATE)+","+game.getReleased().get(Calendar.YEAR),games.getGame("The two thrones").ToString());
	}

	@Test
	public void testRemoveGameString() {
		GameList games=new GameList();
		Game game=new Game();
		game.setName("The two thrones");
		game.getReleased().set(1999,9,29);
		game.setTotalTrophies(2);
		games.addGame(game);
		
		games.removeGame("The two Thrones");
		Assert.assertEquals(null,games.getGame("The two Thrones"));
	}

	@Test
	public void testRemoveGameGame() {
		GameList games=new GameList();
		Game game=new Game();
		game.setName("The two thrones");
		game.getReleased().set(1999,9,29);
		game.setTotalTrophies(2);
		games.addGame(game);
		
		games.removeGame(game);
		Assert.assertEquals(null,games.getGame("The two Thrones"));
	}

	@Test
	public void testToString() {
		GameList games=new GameList();
		Game game=new Game();
		game.setName("The two thrones");
		game.getReleased().set(1999,9,29);
		game.setTotalTrophies(2);
		games.addGame(game);
		
		
		Assert.assertEquals("\""+game.getName()+"\""+", released on: "+game.getFmt().format("%tb",game.getReleased())+" "+game.getReleased().get(Calendar.DATE)+","+game.getReleased().get(Calendar.YEAR),games.getGame("The two thrones").ToString());
	}
	@Test
	public void testAddGameExists() {
		GameList games=new GameList();
		Game game=new Game();
		game.setName("The two thrones");
		game.getReleased().set(1999,9,29);
		game.setTotalTrophies(2);
		games.addGame(game);
		if(games.getGame("The two thrones")!=null) {
			Assert.assertEquals("\""+game.getName()+"\""+", released on: "+game.getFmt().format("%tb",game.getReleased())+" "+game.getReleased().get(Calendar.DATE)+","+game.getReleased().get(Calendar.YEAR),games.getGame("The two thrones").ToString());
		}
		
		
	}
	@Test(expected=IllegalArgumentException.class)
	public void removeGameNullArg() {
		GameList games=new GameList();
		Game game=null;
		games.removeGame(game);

}
	@Test(expected=IllegalArgumentException.class)
	public void addGameNullArg() {
		GameList games=new GameList();
		Game game=null;
		games.addGame(game);

}
}
